# emacs-mode: -*- python-*-
from Plasma import *
from PlasmaTypes import *
import string
actTrigger = ptAttribActivator(1, 'Activator')
stringVarName = 'ElevatorAtTop'
stringInfo = 'ElevatorAtTop'
boolCurrentValue = false
AgeStartedIn = None

class relltooElevatorLogic(ptResponder):
    __module__ = __name__

    def __init__(self):
        ptResponder.__init__(self)
        self.id = 103350002
        self.version = 1
        self.elevatorUpTimerId = 1
        self.flapsUpTimerId = 3
        self.triggerSuppressTimerId = 4


    def OnFirstUpdate(self):
        global AgeStartedIn
        AgeStartedIn = PtGetAgeName()


    def OnServerInitComplete(self):
        global boolCurrentValue
        if (AgeStartedIn == PtGetAgeName()):
            ageSDL = PtGetAgeSDL()
            if (stringVarName != ''):
                ageSDL.setNotify(self.key, stringVarName, 0.0)
                ageSDL.setFlags(stringVarName, 1, 1)
                ageSDL.sendToClients(stringVarName)
                # Heck - lets do this for flaps down too, since the dang
                # AlcScript for enabling/disabling the collider ain't working
                ageSDL.setNotify(self.key, 'FlapsDown', 0.0)
                ageSDL.setFlags('FlapsDown', 1, 1)
                ageSDL.sendToClients('FlapsDown')
                self.SetFloorCollider()
                self.SetActivator(0)
                try:
                    boolCurrentValue = ageSDL[stringVarName][0]
                except:
                    PtDebugPrint('ERROR: relltooElevatorLogic.OnServerInitComplete():\tERROR reading age SDL')
                PtDebugPrint(('DEBUG: relltooElevatorLogic.OnServerInitComplete():\t%s = %d' % (stringVarName,
                 boolCurrentValue)))
            else:
                PtDebugPrint('ERROR: relltooElevatorLogic.OnServerInitComplete():\tERROR: missing SDL var name')



    def OnNotify(self, state, id, events):
        global boolCurrentValue
        if ((not state) or (id != actTrigger.id)):
            return 
        if (not PtWasLocallyNotified(self.key)):
            return 
        elif ((type(actTrigger.value) == type([])) and (len(actTrigger.value) > 0)):
            PtDebugPrint(('DEBUG: relltooElevatorLogic.OnNotify():\t local player requesting %s change via %s' % (stringVarName,
             actTrigger.value[0].getName())))
        if (stringVarName == ''):
            PtDebugPrint('ERROR: relltooElevatorLogic.OnNotify():\tERROR: missing SDL var name')
            return 
        if (AgeStartedIn == PtGetAgeName()):
            ageSDL = PtGetAgeSDL()
            if boolCurrentValue:
                boolCurrentValue = false
                # Trigger the flaps to raise after the elevator has finished
                PtAtTimeCallback(self.key,0,self.flapsUpTimerId)
                
            else:
                if (not ageSDL['FlapsDown'][0]):
                    # Trigger the flaps to go down
                    ageSDL.setIndex('FlapsDown',0,true)
                    # If the air vent is open, trigger the elevator to go up once the flaps have fallen
                    if (ageSDL['AirVentOpen'][0]):
                         PtAtTimeCallback(self.key,0,self.elevatorUpTimerId)
            ageSDL.setTagString(stringVarName, stringInfo)
            ageSDL.setIndex(stringVarName,0,boolCurrentValue)
            PtDebugPrint(('DEBUG: relltooElevatorLogic.OnNotify():\tset age SDL var %s to %d' % (stringVarName,
             boolCurrentValue)))

    def SetFloorCollider(self):
        ageSDL = PtGetAgeSDL()
        tempBool = ageSDL['FlapsDown'][0]
        floorObj = PtFindSceneobject('E_platforms_coll',AgeStartedIn)
        if (tempBool):
            floorObj.physics.suppress(true)
        else:
            floorObj.physics.suppress(false)

    def SetActivator(self, actstate):
        ageSDL = PtGetAgeSDL()
        trigObj = PtFindSceneobject('Elevator_control_trig',AgeStartedIn)
        if (actstate):
            trigObj.physics.suppress(true)
        else:
            trigObj.physics.suppress(false)

    def OnSDLNotify(self, VARname, SDLname, playerID, tag):
        global boolCurrentValue
        if (AgeStartedIn == PtGetAgeName()):
            ageSDL = PtGetAgeSDL()
            if (VARname == stringVarName):
                PtDebugPrint(('DEBUG: relltooElevatorLogic.OnSDLNotify():\t VARname:%s, SDLname:%s, tag:%s, value:%d' % (VARname,
                 SDLname,
                 tag,
                 ageSDL[stringVarName][0])))
                boolCurrentValue = ageSDL[stringVarName][0]
                self.SetActivator(1)                                        # Suppress "start button"
                PtAtTimeCallback(self.key,14,self.triggerSuppressTimerId)   # whilst the lift is moving
            elif (VARname == 'FlapsDown'):
                PtDebugPrint(('DEBUG: relltooElevatorLogic.OnSDLNotify():\t VARname:%s, SDLname:%s, tag:%s, value:%d' % (VARname,
                 SDLname,
                 tag,
                 ageSDL[VARname][0])))
                self.SetFloorCollider()


    def OnTimer(self, id):
        ageSDL = PtGetAgeSDL()
        if (id == self.elevatorUpTimerId):
            ageSDL.setIndex('ElevatorAtTop',0,true)
        elif (id == self.flapsUpTimerId):
            ageSDL.setIndex('FlapsDown',0,false)
        elif (id == self.triggerSuppressTimerId):
            self.SetActivator(0)          # reactivate "start button" after the lift has stopped moving (ca.14s)


### Python Glue ###

glue_cl = None
glue_inst = None
glue_params = None
glue_paramKeys = None
try:
    x = glue_verbose
except NameError:
    glue_verbose = 0

def glue_getClass():
    global glue_cl
    if (glue_cl == None):
        try:
            cl = eval(glue_name)
            if issubclass(cl, ptModifier):
                glue_cl = cl
            elif glue_verbose:
                print ('Class %s is not derived from modifier' % cl.__name__)
        except NameError:
            if glue_verbose:
                try:
                    print ('Could not find class %s' % glue_name)
                except NameError:
                    print 'Filename/classname not set!'
    return glue_cl


def glue_getInst():
    global glue_inst
    if (type(glue_inst) == type(None)):
        cl = glue_getClass()
        if (cl != None):
            glue_inst = cl()
    return glue_inst


def glue_delInst():
    global glue_inst
    global glue_cl
    global glue_paramKeys
    global glue_params
    if (type(glue_inst) != type(None)):
        del glue_inst
    glue_cl = None
    glue_params = None
    glue_paramKeys = None


def glue_getVersion():
    inst = glue_getInst()
    ver = inst.version
    glue_delInst()
    return ver


def glue_findAndAddAttribs(obj, glue_params):
    if isinstance(obj, ptAttribute):
        if glue_params.has_key(obj.id):
            if glue_verbose:
                print 'WARNING: Duplicate attribute ids!'
                print ('%s has id %d which is already defined in %s' %
                      (obj.name, obj.id, glue_params[obj.id].name))
        else:
            glue_params[obj.id] = obj
    elif type(obj) == type([]):
        for o in obj:
            glue_findAndAddAttribs(o, glue_params)
    elif type(obj) == type({}):
        for o in obj.values():
            glue_findAndAddAttribs(o, glue_params)
    elif type(obj) == type(()):
        for o in obj:
            glue_findAndAddAttribs(o, glue_params)


def glue_getParamDict():
    global glue_paramKeys
    global glue_params
    if type(glue_params) == type(None):
        glue_params = {}
        gd = globals()
        for obj in gd.values():
            glue_findAndAddAttribs(obj, glue_params)
        glue_paramKeys = glue_params.keys()
        glue_paramKeys.sort()
        glue_paramKeys.reverse()
    return glue_params


def glue_getClassName():
    cl = glue_getClass()
    if (cl != None):
        return cl.__name__
    if glue_verbose:
        print ('Class not found in %s.py' % glue_name)
    return None


def glue_getBlockID():
    inst = glue_getInst()
    if (inst != None):
        return inst.id
    if glue_verbose:
        print ('Instance could not be created in %s.py' % glue_name)
    return None


def glue_getNumParams():
    pd = glue_getParamDict()
    if (pd != None):
        return len(pd)
    if glue_verbose:
        print ('No attributes found in %s.py' % glue_name)
    return 0


def glue_getParam(number):
    pd = glue_getParamDict()
    if (pd != None):
        if type(glue_paramKeys) == type([]):
            if (number >= 0) and (number < len(glue_paramKeys)):
                return pd[glue_paramKeys[number]].getdef()
            else:
                print ('glue_getParam: Error! %d out of range of attribute list' % number)
        else:
            pl = pd.values()
            if (number >= 0) and (number < len(pl)):
                return pl[number].getdef()
            elif glue_verbose:
                print ('glue_getParam: Error! %d out of range of attribute list' % number)
    if glue_verbose:
        print 'GLUE: Attribute list error'
    return None


def glue_setParam(id, value):
    pd = glue_getParamDict()
    if (pd != None):
        if pd.has_key(id):
            try:
                pd[id].__setvalue__(value)
            except AttributeError:
                if isinstance(pd[id], ptAttributeList):
                    try:
                        if type(pd[id].value) != type([]):
                            pd[id].value = []
                    except AttributeError:
                        pd[id].value = []
                    pd[id].value.append(value)
                else:
                    pd[id].value = value
        elif glue_verbose:
            print "setParam: can't find id=", id
    else:
        print 'setParma: Something terribly has gone wrong. Head for the cover.'


def glue_isNamedAttribute(id):
    pd = glue_getParamDict()
    if (pd != None):
        try:
            if isinstance(pd[id], ptAttribNamedActivator):
                return 1
            if isinstance(pd[id], ptAttribNamedResponder):
                return 2
        except KeyError:
            if glue_verbose:
                print ('Could not find id=%d attribute' % id)
    return 0


def glue_isMultiModifier():
    inst = glue_getInst()
    if isinstance(inst, ptMultiModifier):
        return 1
    return 0


def glue_getVisInfo(number):
    pd = glue_getParamDict()
    if pd != None:
        if type(glue_paramKeys) == type([]):
            if (number >= 0) and (number < len(glue_paramKeys)):
                return pd[glue_paramKeys[number]].getVisInfo()
            else:
                print ('glue_getVisInfo: Error! %d out of range of attribute list' % number)
        else:
            pl = pd.values()
            if (number >= 0) and (number < len(pl)):
                return pl[number].getVisInfo()
            elif glue_verbose:
                print ('glue_getVisInfo: Error! %d out of range of attribute list' % number)
    if glue_verbose:
        print 'GLUE: Attribute list error'
    return None
